## ros-melodic-video-stream-opencv 1.1.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(video_stream_opencv)
add_definitions(-std=c++11)

find_package(catkin REQUIRED COMPONENTS
  roscpp
  rospy
  cv_bridge
  image_transport
  camera_info_manager
  sensor_msgs
  nodelet
  dynamic_reconfigure)


find_package(OpenCV)

generate_dynamic_reconfigure_options(
  cfg/VideoStream.cfg)

catkin_package()

include_directories(
  ${catkin_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS})

add_library(${PROJECT_NAME} SHARED src/video_stream.cpp)
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES} ${OpenCV_LIBRARIES})
add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_gencfg)

add_executable(video_stream_node src/video_stream_node.cpp)
target_link_libraries(video_stream_node ${catkin_LIBRARIES})
set_target_properties(video_stream_node PROPERTIES OUTPUT_NAME video_stream)

install(TARGETS video_stream_node ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(PROGRAMS
  scripts/test_video_resource.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(DIRECTORY launch test
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  USE_SOURCE_PERMISSIONS)

install(FILES nodelet_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

if (CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  add_rostest(test/test_video_file.test)
  add_rostest(test/test_mjpg_stream.test)
  add_rostest(test/test_rtsp_stream.test)
endif()

=== debian/changelog ===
ros-melodic-video-stream-opencv (1.1.6-1stretch) stretch; urgency=high

  * #67 Deal better with looping on a video file and the start and stop frame selection
  * #77 Noticed the default camera info was actually wrong, corrected
  * #69 Get canonical file for target device and give a warning if we convert to a canonical path
  * Fix typo when moving log to debug
  * #57 Enable to select the start and stop points for playing video file.
  * Avoid the excess of start_frame compared to stop_frame for playing video file.
  * #55 Add title and travis badge
  * #54 Enable testing on melodic
  * Add linesep for each mp jpeg
  * #53 Upgrade to OpenCV 4
  * #52 video_stream: fix disconnect callbacks never being called
  * Video_stream: make sure to always increase suscriber count
  * #50 Add option to set output_encoding
  * Add link to cv_bridge::cvtColor
  * Add config to set output_encoding
  * #49 Use variable config instead of class properties
  * #51 install with source permissions, install small.mp4, install test directory to enable testing in catkin install space
  * #45 libvideo_stream_opencv now depends on gencfg
  * #44 Don't download test data on source directory
  * #43 Add option to re-open camera device on read failure
  * #39 Add dependency for gencfg
  * #37 Support camera property settings on dynamic reconfigure
  * #36 Fix bugs for thread initialization/deinitialization
  * #34 Support changing parameter by using dynamic reconfigure
  * Add dependencies for test
  * Support dynamic_reconfigure
  * #33 Convert video_stream node to nodelet, use nodelet for video_stream
  * #31 Do not flip old image multiple times, closes #30
  * #35 Enable CI
  * Contributors: Alexander Rössler, GITAI, Leonardo Lai, Michael Sobrepera, Ryohei Ueda, Sam Pfeiffer, Sammy Pfeiffer, Yuki Furuta, moju zhao

 -- Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>  Mon, 07 Dec 2020 13:00:00 -0000

ros-melodic-video-stream-opencv (1.1.5-1stretch) stretch; urgency=high

  * Exit the program if we reach the end of the video when playing a video file (Issue #23)
  * Throw exception when a frame cant be captured (Issue #23, PR #27)
  * Add loop_video parameter for videofiles (PR #24)
  * Contributors: Sammy Pfeiffer, iory

 -- Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>  Thu, 13 Dec 2018 13:00:00 -0000

ros-melodic-video-stream-opencv (1.1.4-1stretch) stretch; urgency=high

  * Fix bug, cv::Mat needs to be cloned otherwise all entries in the queue will point to the same frame. This resulted in always returning the last received frame.
  * Contributors: Axel13fr

 -- Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>  Sun, 22 Jul 2018 14:00:00 -0000

ros-melodic-video-stream-opencv (1.1.3-1stretch) stretch; urgency=high

  * Fixing ever growing memory when using boost::sync_queue (Issue #20) by reimplementing thread safety of frames queue using std classes. boost::sync_queue is buggy (keeps on allocating memory over time).
  * Contributors: Axel13fr

 -- Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>  Tue, 10 Jul 2018 14:00:00 -0000

ros-melodic-video-stream-opencv (1.1.2-1stretch) stretch; urgency=high

  * Fix empty frame id in camera info header when providing a calibration file.
  * Contributors: tim-fan

 -- Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>  Mon, 11 Jun 2018 14:00:00 -0000

ros-melodic-video-stream-opencv (1.1.1-1stretch) stretch; urgency=high

  * Fix error of using camera_name instead of identifying the type of the provider
    to check when the provider is a video file, and act accordingly in the producer thread
  * Prevent locking when ROS SIGINT arrives and the image queue is empty.
  * Added rate limiting to camera_fps_rate also if videofile is used as input
  * Contributors: Andrea Ranieri, Avio, Sam Pfeiffer, Sammy Pfeiffer

 -- Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>  Thu, 19 Apr 2018 14:00:00 -0000

ros-melodic-video-stream-opencv (1.1.0-1stretch) stretch; urgency=high

  * Update to use thread to read.
    Update to new parameters.
    Update description.
  * Fixed image flip bug, the flip implementation is inconsistent with OpenCV API.
  * Contributors: Sammy Pfeiffer, Zihan Chen, kantengri

 -- Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>  Thu, 22 Mar 2018 13:00:00 -0000

ros-melodic-video-stream-opencv (1.0.2-1stretch) stretch; urgency=high



 -- Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>  Sun, 13 Nov 2016 13:00:00 -0000

ros-melodic-video-stream-opencv (1.0.1-1stretch) stretch; urgency=high

  * Releasable version
  * Contributors: Sammy Pfeiffer, Stefano Probst, Wiebe Van Ranst

 -- Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>  Sun, 13 Nov 2016 13:00:00 -0000

=== debian/control ===
Source: ros-melodic-video-stream-opencv
Section: misc
Priority: optional
Maintainer: Sammy Pfeiffer <Sammy.Pfeiffer@student.uts.edu.au>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-camera-info-manager, ros-melodic-catkin, ros-melodic-cv-bridge, ros-melodic-dynamic-reconfigure, ros-melodic-image-transport, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-rostest, ros-melodic-rostopic, ros-melodic-sensor-msgs
Homepage: http://www.ros.org/wiki/video_stream_opencv
Standards-Version: 3.9.2

Package: ros-melodic-video-stream-opencv
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-camera-info-manager, ros-melodic-cv-bridge, ros-melodic-dynamic-reconfigure, ros-melodic-image-transport, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-sensor-msgs
Description: The video_stream_opencv package contains a node to publish a video stream (the protocols that opencv supports are supported, including rtsp, webcams on /dev/video and video files) in ROS image topics, it supports camera info and basic image flipping (horizontal, vertical or both) capabilities, also adjusting publishing rate.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-video-stream-opencv//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
